Package com.xebialabs.xlrelease.domain.facet

# Class Facet

java.lang.Object
com.xebialabs.deployit.plugin.api.udm.base.BaseConfigurationItem
com.xebialabs.xlrelease.domain.facet.Facet

All Implemented Interfaces:
  `ConfigurationItem`, `VisitableItem`, `Serializable`, `Comparable<BaseConfigurationItem>`

Direct Known Subclasses:
  `ConfigurationFacet`, `TaskReportingRecord`

@Metadata(root=APPLICATIONS, versioned=false, virtual=true, description="Base facet class used to augment other CIs (tasks only currently)") public abstract class Facet extends BaseConfigurationItem implements VisitableItem

See Also:
  - Serialized Form

- ## Field Summary

  Fields
  Modifier and Type
  Field
  Description
  `static final String`
  `CONFIGURATION_URI`
  `protected FacetScope`
  `scope`

  ### Fields inherited from class com.xebialabs.deployit.plugin.api.udm.base.BaseConfigurationItem

  `id, syntheticProperties, type`

  ### Fields inherited from interface com.xebialabs.deployit.plugin.api.udm.ConfigurationItem

  `SYNTHETIC_PROPERTIES_FIELD, TYPE_FIELD`

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `Facet()`

- ## Method Summary

  Modifier and Type
  Method
  Description
  `void`
  `accept(ReleaseVisitor visitor)`
  `Set<String>`
  `freezeVariables(Map<String,ValueWithInterpolation> variables, Changes changes, boolean freezeEvenIfUnresolved)`
  `Collection<PropertyDescriptor>`
  `getPropertiesWithVariables()`
  `FacetScope`
  `getScope()`
  `String`
  `getTargetId()`
  `Map<String,String>`
  `getVariableMapping()`
  `List<UsagePoint>`
  `getVariableUsages()`
  `void`
  `setScope(FacetScope scope)`
  `void`
  `setTargetId(String targetId)`
  `void`
  `setVariableMapping(Map<String,String> variableMapping)`

  ### Methods inherited from class com.xebialabs.deployit.plugin.api.udm.base.BaseConfigurationItem

  `compareTo, equals, get$ciAttributes, get$directoryReference, get$externalProperties, get$internalId, get$referenceId, get$securedCi, get$securedDirectoryReference, get$token, get$validationMessages, getId, getName, getProperty, getPropertyDescriptor, getType, hashCode, hasProperty, set$ciAttributes, set$directoryReference, set$externalProperties, set$internalId, set$referenceId, set$securedCi, set$securedDirectoryReference, set$token, set$validationMessages, setId, setProperty, setType, toString`

  ### Methods inherited from class java.lang.Object

  `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

- ## Field Details

  - ### CONFIGURATION_URI

    public static final String CONFIGURATION_URI
    See Also:
      - Constant Field Values

  - ### scope

    @Property(hidden=true, category="internal", description="CI kind to which the facet can be applied.", defaultValue="TASK") protected FacetScope scope

- ## Constructor Details

  - ### Facet

    public Facet()

- ## Method Details

  - ### getScope

    public FacetScope getScope()

  - ### setScope

    public void setScope(FacetScope scope)

  - ### getTargetId

    public String getTargetId()

  - ### setTargetId

    public void setTargetId(String targetId)
    Parameters:
      `targetId` - The ID of the CI that generated the record, e.g. the `task.id`

  - ### accept

    public void accept(ReleaseVisitor visitor)
    Specified by:
      `accept` in interface `VisitableItem`

  - ### getVariableUsages

    public List<UsagePoint> getVariableUsages()

  - ### getVariableMapping

    public Map<String,String> getVariableMapping()

  - ### setVariableMapping

    public void setVariableMapping(Map<String,String> variableMapping)

  - ### freezeVariables

    public Set<String> freezeVariables(Map<String,ValueWithInterpolation> variables, Changes changes, boolean freezeEvenIfUnresolved)

  - ### getPropertiesWithVariables

    public Collection<PropertyDescriptor> getPropertiesWithVariables()